package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.eam.core.eam_core.domain.EMResRefObj;
import cn.ibizlab.eam.core.eam_core.filter.EMResRefObjSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMResRefObj] 服务对象接口
 */
public interface IEMResRefObjService extends IService<EMResRefObj>{

    boolean create(EMResRefObj et) ;
    void createBatch(List<EMResRefObj> list) ;
    boolean update(EMResRefObj et) ;
    void updateBatch(List<EMResRefObj> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMResRefObj get(String key) ;
    EMResRefObj getDraft(EMResRefObj et) ;
    boolean checkKey(EMResRefObj et) ;
    boolean save(EMResRefObj et) ;
    void saveBatch(List<EMResRefObj> list) ;
    Page<EMResRefObj> searchDefault(EMResRefObjSearchContext context) ;
    Page<EMResRefObj> searchIndexDER(EMResRefObjSearchContext context) ;
    List<EMResRefObj> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMResRefObj> selectByResrefobjpid(String emresrefobjid) ;
    void removeByResrefobjpid(String emresrefobjid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EMResRefObj> getEmresrefobjByIds(List<String> ids) ;
    List<EMResRefObj> getEmresrefobjByEntities(List<EMResRefObj> entities) ;
}


